#include <stdio.h>
#include <stdlib.h>
/*
  Arquivo: base.h
  Autor: Glauber Costa
  Data: 21/02/2008
  Objetivo: Repositorio de funcoes utilizadas nos diversos metodos de
  ordenacao da disciplina Ordenacao e Pesquisa
*/

/*
  Nome: alocar_vetor
  Objetivo: alocar um vetor com n posicoes
  Parametros: int n indica o tamanho do vetor a ser gerado
  Retorno: um ponteiro para o vetor alocado
  Autor: Glauber Costa
  Data: 21/02/2008
*/
int *alocar_vetor (int n)
{
  int *v;        /* ponteiro para o vetor */
  if (n < 1) {  /* verifica parametros recebidos */
     printf ("** Nao e possivel alocar vetor sem posicoes **\n");
     return (NULL);
     }
  /* aloca o vetor */
  v =  calloc (n, sizeof(int));
  if (v == NULL) {
     printf ("** Erro: Memoria Insuficiente **");
     return (NULL);
     }
  return (v);    /* retorna o ponteiro para o vetor */
}

/*
  Nome: gera_aleatorio
  Objetivo: gera um numer aleatorio
  Parametros: int max indica a faixa de valores dentro da qual o numero deve ser gerado
  Retorno: o numero aleatorio gerado
  Autor: Glauber Costa
  Data: 21/02/2008
*/
int gera_aleatorio(int max){
     return rand()%max;
}

/*
  Nome: preenche_vetor
  Objetivo: preenche um vetor com numeros aleatorios
  Parametros: int *vetor ponteiro para o vetor a ser preenchido
  Parametros: int tam tamanho do vetor a ser gerado
  Retorno: nada
  Autor: Glauber Costa
  Data: 21/02/2008
*/
void preenche_vetor(int *vetor, int tam){
       int i;
       srand(time(NULL));
       for(i=0;i<tam;i++)
           vetor[i] = gera_aleatorio(tam*tam);
     }

/*
  Nome: imprime_vetor
  Objetivo: imprime um vetor
  Parametros: int *vetor ponteiro para o vetor a ser impresso
  Parametros: int tam tamanho do vetor a ser impresso
  Retorno: nada
  Autor: Glauber Costa
  Data: 21/02/2008
*/
void imprime_vetor(int *vetor, int start, int end){
       int i;
       for(i=start;i<end;i++)
           printf("%d ",vetor[i]);
     }
     
void libera_vetor(int *var){
     free(var);
}

/*
  Nome: inverte
  Objetivo: fazer o vetor ficar com os valores decrescentes
  Parametros: int *vetor ponteiro para o vetor a ser impresso
  Parametros: int tam tamanho do vetor a ser impresso
*/
void inverte(int *v, int n){
    int i;
    int *y;
    y=alocar_vetor(n);
    for(i=0;i<n;i++){
                     y[i]=v[(n-1)-i];
    }
    for(i=0;i<n;i++){
                     v[i]=y[i];
    }
    libera_vetor(y);
}
